' EncodeScriptByBase64.VBS V1.01 (C) yoshioka.teruo@nifty.com 2005-07-27
' EncodeScriptByBase64.VBS encodes script by Base64.
' Usage: Start EncodeScriptByBase64.VBS files...

Option Explicit

Dim fso
Dim arg
Dim File
Dim iPath
Dim iName
Dim FolderName
Dim BaseName
Dim ExtensionName
Dim Ext
Dim Source
Dim Language
Dim oName
Dim oPath
Dim BackUp
Dim k
Dim FileName
Dim TextFile

Set fso=CreateObject("Scripting.FileSystemObject")

For Each arg In WScript.Arguments
  Set File=fso.GetFile(arg)
  iPath=File.Path
  iName=File.Name
  FolderName=fso.GetParentFolderName(iPath)
  BaseName=fso.GetBaseName(iName)
  ExtensionName=fso.GetExtensionName(iName)
  Ext=".WSF"
  Source=fso.OpenTextFile(iPath).ReadAll()
  Source=ToBase64(Source)
  Select Case(LCase(ExtensionName))
  Case "pls" Language="PerlScript"
  Case "js" Language="JScript"
  Case Else Language="VBScript"
  End Select
  oName=BaseName&Ext
  oPath=fso.BuildPath(FolderName,oName)
  BackUp=""
  If fso.FileExists(oPath) Then
    Set File=fso.GetFile(oPath)
    For k=1000 To 1999
      FileName=BaseName & "." & Right(k ,3)
      Call Rename(File,FileName)
      If Err=0 Then
        Exit For
      ElseIf Err<>58 Then
        WScript.Echo Err.Number & " : " & Err.Description
        WSscript.Quit
      End If
    Next
    BackUp=vbLf & "BackUp" & vbTab & FileName
  End If
  Set TextFile=fso.CreateTextFile(oPath,False)
  TextFile.Write Join(Array(_
"<"&"?xml version=""1.0"" encoding=""utf-7""?"&">",_
"<"&"job"&">",_
"<"&"script language="""&Language&""">"&"<"&"![CDATA[",_ 
"+"),vbCrLf)
  TextFile.Write Source
  TextFile.Write Join(Array(_
"-",_
"]]"&">"&"<"&"/script"&">",_
"<"&"/job"&">",_
""),vbCrLf)
  TextFile.Close
  WScript.Echo "Script Encoded." & vbLf _
             & "To" & vbTab & oName & vbLf _
             & "From" & vbTab & iName & Backup
Next
WScript.Quit

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

Function ToBase64(Src)
Dim BASE64:BASE64="ABCDEFGHIJKLMNOPQRSTUVWXYZ" & _
                  "abcdefghijklmnopqrstuvwxyz" & _
                  "0123456789+/"
Dim k
Dim Bytes
Dim Code
Dim Dst

ReDim Bytes(LenB(Src))
For k=1 To Len(Src)
  Code=AscW(Mid(Src,k,1))
  If Code<0 Then Code=Code+256*256
  Bytes(k*2-1)=Code \ 256
  Bytes(k*2)=Code Mod 256
Next
For k=1 To UBound(Bytes) Step 3
  Dst=Dst & Mid(BASE64,(Bytes(k) \ 4)+1,1)
  If k+1>UBound(Bytes) Then
    Dst=Dst & Mid(BASE64,(Bytes(k)*16 Mod 64)+1,1)
  Else
    Dst=Dst & Mid(BASE64,(Bytes(k)*16 Mod 64)+(Bytes(k+1) \ 16)+1,1)
    If k+2>UBound(Bytes) Then
      Dst=Dst & Mid(BASE64,(Bytes(k+1)*4 Mod 64)+1,1)
    Else
      Dst=Dst & Mid(BASE64,(Bytes(k+1)*4 Mod 64)+(Bytes(k+2) \ 64)+1,1)
      Dst=Dst & Mid(BASE64,(Bytes(k+2) Mod 64)+1,1)
    End If
  End If
Next
ToBase64=Dst
End Function
